#include "StdAfx.h"
#include "IdleMonitor.h"
bool g_bMonitorStarted=false;
HWND g_hNotifyWnd;
UINT g_nNotifyMsg;
UINT g_nAwayTimer;
UINT g_nTimer;
CIdleMonitor::CIdleMonitor(void)
{
}

CIdleMonitor::~CIdleMonitor(void)
{
}

BOOL IsAway( LASTINPUTINFO &LastInput );

VOID CALLBACK TimerProc_UserInput(HWND hwnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	LASTINPUTINFO LastInput;
	LastInput.dwTime = 0;
	LastInput.cbSize = sizeof(LASTINPUTINFO);
	if(GetLastInputInfo(&LastInput))
	{
		if(IsAway(LastInput)) 
		{
			::PostMessage(g_hNotifyWnd,g_nNotifyMsg,MONITOR_ID_AWAY,TRUE);
		}
		else
		{
			::PostMessage(g_hNotifyWnd,g_nNotifyMsg,MONITOR_ID_NOT_AWAY,FALSE);
		}
	}
	else
	{
		::PostMessage(g_hNotifyWnd,g_nNotifyMsg,MONITOR_ID_NOT_AWAY,FALSE);
	}
}

BOOL IsAway( LASTINPUTINFO &LastInput )
{
	return GetTickCount() - LastInput.dwTime > (DWORD)(GET_CONFIG()->GetAutoAwayTime() * 60000) ? TRUE : FALSE;
}

BOOL CIdleMonitor::MonitorSetUserInput(HWND hNotifyWnd,UINT nNotifyMsg)
{
	BOOL bRet=TRUE;
	if(hNotifyWnd !=NULL)
	{
		g_hNotifyWnd=hNotifyWnd;
		g_nNotifyMsg=nNotifyMsg;
	}
	else
		bRet =FALSE;
	return bRet;
}
BOOL CIdleMonitor::MonitorStartUserInput()
{
	return ResumeMonitorInput();
}
BOOL CIdleMonitor::ResumeMonitorInput()
{
	BOOL bRet=TRUE;
	if(!g_bMonitorStarted && g_hNotifyWnd!=NULL)
	{
		g_bMonitorStarted = true;
		g_nTimer=(UINT)::SetTimer(NULL,TIMER_IDLE_MONITOR,1000,TimerProc_UserInput);
	}
	else
	{
		g_bMonitorStarted = true;
		::KillTimer(NULL,g_nTimer);
		g_nTimer=(UINT)::SetTimer(NULL,TIMER_IDLE_MONITOR,1000,TimerProc_UserInput);
		bRet =FALSE;
	}
	return bRet;
}
BOOL CIdleMonitor::PauseMonitorInput()
{
	g_bMonitorStarted=false;
	::KillTimer(NULL,g_nTimer);
	return TRUE;
}
BOOL CIdleMonitor::MonitorStopUserInput()
{
	g_bMonitorStarted=false;
	::KillTimer(NULL,g_nTimer);
	return TRUE;
}